;- filename from screen check
;
resid="TC"
debug=0
FastExit=0
;
code	segment byte public 'CODE'
assume	cs:code
org	100h
start:	jmp	begin
;
;
;
;
STMaxStrLen equ 15
STEntrySize equ STMaxStrLen+3	; X,Y,Len
STEntryNum  equ 4

CFGData:
StrTable db STEntrySize*STEntryNum dup (0)
NoEMMDrives dd 3	;- BitTable of 32 Drives, which use DMA -> don't use EMS
			;- default: A: and B:
ShiftDisable db 1	;- Disable TC, if rightshift is down
PrgChar	db ""
;
;
;
OldInt21	dd 0
;
;
;
RHandle 	dw -1	;- Src-FileHandle
WHandle 	dw -1	;- Trg-FileHandle
rdrive		db 0	;- Drive of src-file (1=A:...)
wdrive		db 0	;- Drive of trg-file
DrvChecked	db 0	;- 1, if DriveCheck was done

fsize		dd 0	;- FileSize
rleft		dd 0	;- all bytes left to read (for return to caller)
BytesDone	dd 0	;- how many bytes of file already read -> for progression bar
rsize		dd 0	;- Size of filled (read) buffer -> bytes to write
rbufsize	dw 0	;- Size to read at one step
ReadDone	dw 0	;- <>0, if EOF reached (word, because DI is used ;)
WriteDone	dw 0	;- <>0, if ReadDone, and buffer written
WriteErr	db 0	;- <>0, if WriteError occured

bufsize 	dd 0	;- Size of whole buffer in bytes (multiple of 64K)
bufpages	dw 0	;- Size of whole buffer in pages (multiple of 4 pages)

frmseg	dw 0	;- Seg of EMS-Frame
error	db 0	;- <>0 if error (in EMM => Give org.-DOS a chance ;)
doserr	dw 0	;- DOS-Error-code
secsize dw 512	;- Sectorsize in bytes

emmhandle	dw 0
WasteBuf	dw 0	;- size of wasted bytes at each 64K buf
Allocated	db 0	;- is 1, if buffer is allocated (to be freed)

Break	db 0
;

p386
locals
assume cs:code, ds:nothing, es:nothing, ss:nothing
;
;
PushAE macro
	db	66h
	pusha
endm
PopAE macro
	db	66h
	popa
endm

dbg macro dat
	push 	es        
	push 	0b800h    
	pop	es        
	mov	word ptr es:[0],dat+0100h
	pop	es
endm


;
ClrBrk proc near
	mov	Break,0
	push	es
	 push	40h
	 pop	es
	 and	byte ptr es:[71h],7Fh
	pop	es

	ret
endp
;
ChkBrk proc near
;-OUT:	CF=1, if break
	push	es
	push	bx

	push	40h
	pop	es

	test	byte ptr es:[71h],80h
	jnz	@@brk

	mov	bx,es:[1Ah]
	cmp	bx,es:[1Ch]
	je	@@nobrk
	cmp	byte ptr es:[bx],27
	jne	@@nobrk
	@@brk:
	mov	break,1
	stc
	jmp	@@exit
	@@nobrk:
	clc
	@@exit:
	pop	bx
	pop	es
	ret
endp
;
SetMapping proc near
;- IN:	BP=BeginPage, DX=Handle
;-OUT:	BP=next BeginPage, (AX destroyed)

	xchg	bx,bp	;-> BX=PAGE, BP=xHandle

	push	cx
	mov	cx,4

	xor	ax,ax
	;- AL=0 (logical page in pageframe), BX=physical EMS-page
@@l:
	 mov	ah,44h
	 int	67h
	 inc	bx
	 inc	al
	loop	@@l

	pop	cx

	;- if bufpages is below 4, this could cause an error-signal
	;- but should be no problem, because there is no error-check anyway ;)
	;- (and DOS won't read more than needed -> no access at undefined)

	xchg	bx,bp	;-> BX=xHandle, BP=PAGE (next)

	ret
endp
;
StoreMapping proc near
;- IN:	DX=EMMHandle
;- OUT: (AH/AX destroyed)
	mov	ah,47h
	int	67h
	ret
endp
;
RestoreMapping proc near
;- IN:	DX=EMMHandle
;- OUT: (AH/AX destroyed)
	mov	ah,48h
	int	67h
	ret
endp
;
ReadBuf proc near
	pushae
	push	ds

	cmp	ReadDone,0
	jne	short @@Exit

	mov	esi,RSize
	test	esi,esi
	jnz	@@Exit

	call	ClrBrk

	mov	ds,frmseg
	mov	cx,rbufsize
	mov	bx,RHandle

	mov	dx,emmhandle
	xor	bp,bp	;- StartPage

	call	StoreMapping
	;
@@ReadLoop:
	;- BX=RHandle, BP=PAGE
;- set mapping
	call	SetMapping

;- fill buf
	mov	ah,3Fh	;- read
	push	dx
	 xor	dx,dx	;- ofs (DS:DX)
	 pushf		;- int	21h
	 call	[OldInt21]
	pop	dx
	jnc	@@NoDosErr
	 mov	doserr,ax
	 mov	ReadDone,1
	 jmp	@@Error
	@@NoDosErr:

	and	eax,0FFFFh	;- only to be sure, noone trashed high(EAX)
	add	esi,eax 	;- <RSIZE>
	add	BytesDone,eax
	call	DrawProgr

	cmp	ax,cx
	sbb	di,di	;- <ReadDone> will get <>0, if AX<CX
	jnz	@@Done
 
	call	ChkBrk
	jc	@@Done

	cmp	bp,bufpages
	jb	@@ReadLoop
	;
@@Done: mov	ReadDone,di
@@Error: mov	RSize,esi

	call	RestoreMapping
;
@@Exit:

	pop	ds
	popae
	ret
endp
;
WriteBuf proc near
	pushae
	push	ds

	cmp	WriteDone,0
	jne	@@Exit

	mov	esi,RSize

	xor	di,di
	mov	ds,frmseg
	xor	ecx,ecx
	mov	cx,rbufsize
	mov	bx,WHandle

	mov	dx,emmhandle
	xor	bp,bp

	call	StoreMapping

	test	esi,esi
	jz	short @@Done
	;
@@WriteLoop:
	;- BX=WHandle, BP=PAGE
;- set mapping
	call	SetMapping

;- fill buf
	sub	esi,ecx ;- <ESI=RSize=left to write>
	ja	@@WriteAll
	 add	cx,si
	 inc	di	;- <WriteDone=true>
	@@WriteAll:

	mov	ah,40h
	push	dx
	 xor	dx,dx	;- ofs (DS:DX)
	 pushf		;- int	21h
	 call	[OldInt21]
	pop	dx
	jnc	@@NoDosErr
	 mov	doserr,ax
	 mov	ReadDone,1
	 jmp	@@Done
	@@NoDosErr:

	and	eax,0FFFFh	;- only to be sure, noone trashed high(EAX)
 	add	BytesDone,eax
	call	DrawProgr

	cmp	ax,cx
	jb	@@DiskFull

	test	di,di	;- <buffer written>
	jz	@@WriteLoop
	;
@@Done:
	mov	ax,ReadDone
	mov	WriteDone,ax
	jmp	@@DiskNotFull
@@DiskFull:
	mov	WriteErr,1
	mov	WriteDone,1
@@DiskNotFull:
	call	RestoreMapping
	mov	RSize,0

;
@@Exit:
	pop	ds
	popae

	ret
endp
;
PrgOfs	dw 0
PrgLen	dw 0
PrgAttr db 00h
PrgOldChr dw 0
OldID	db 0
;
GetProgrPos proc near
	pusha
	push	es

	mov	al,ChkID
	cmp	OldID,al
	jne	@@NoClr
	call	ClrProgr
	@@NoClr:
	mov	OldID,al

	push	0b800h
	pop	es
	
	mov	bx,StrYOfs
	mov	ax,XLen
	add	bx,ax	;- line below ID-Str
	shr	ax,1
	add	bx,ax	;- mid-screen-position


	mov	dl,es:[bx+1]	;- get attr
	shr	dl,4		;- only background-color
	mov	cx,16

	@@l:
	 mov	al,es:[bx]
	 cmp	al,''
	 je	@@pos
	 cmp	al,''
	 je	@@pos
	 cmp	al,''
	 je	@@pos
	 cmp	al,''
	 je	@@pos

	 ;- it's no block-char -> now check, if it's a space with dif. color
	 cmp	al,32
	 jne	@@nextline

	 mov	dh,es:[bx+1]
	 shr	dh,4
	 cmp	dl,dh
	 jne	@@pos	;- it's a space with dif. background-color -> equals block-char
	@@nextline:
	 add	bx,XLen
	loop	@@l
	;- neg
	mov	PrgOfs,0
	mov	PrgLen,0
	jmp	@@exit
	@@pos:
	;- now we are inside progression-bar
	mov	cx,1	;- progr.-bar length
	;- chk left
	mov	ax,es:[bx]
	mov	PrgOldChr,ax
	push	bx

	@@NextLeft:
	 cmp	es:[bx-2],ax
	 jne	@@HitLeft
	 inc	cx
	 sub	bx,2
	jmp	@@NextLeft
	@@HitLeft:
	mov	PrgOfs,bx

	pop	bx
	;- chk right
	@@NextRight:
	 cmp	es:[bx+2],ax
	 jne	@@HitRight
	 inc	cx
	 add	bx,2
	jmp	@@NextRight
	@@HitRight:
	mov	PrgLen,cx

	mov	PrgAttr,01h
	cmp	al,' '
	jne	@@AttrDone
	shr	ah,4
	jnz	@@AttrDone
	 rol	PrgAttr,4
	@@AttrDone:

	@@exit:
	pop	es
	popa

	ret
endp
;
DrawProgr proc near
	pushae
	push	es
	pushf

	cmp	PrgLen,0
	jz	@@exit

	push	0b800h
	pop	es

	xor	ecx,ecx
	mov	cx,PrgLen
	shl	cx,1	;- to get the "half"-blocks too
	mov	ebx,FSize
	shl	ebx,1	;- to reflect read AND write

	mov	eax,BytesDone
	mul	ecx
	div	ebx
	shr	ax,1
	sbb	bx,bx	;- if CF=1 then BX:=-1, ELSE BX:=0
	mov	cx,ax
	
	cld
	mov	al,PrgChar
	mov	ah,PrgAttr
	mov	di,PrgOfs
	rep	stosw
	
	test	bx,bx
	jz	@@exit
	 mov	ah,byte ptr PrgOldChr[1]
	 mov	al,''
	 stosw
	@@exit:
	
	popf
	pop	es
	popae
	ret
endp
;
ClrProgr proc near
	cmp	PrgLen,0
	jz	@@exit

	pushf
	pusha
	push	es

	push	0b800h
	pop	es

	cld
	mov	cx,PrgLen
	mov	ax,PrgOldChr
	mov	di,PrgOfs
	rep	stosw

	pop	es
	popa
	popf

	@@exit:
	ret
endp
;
InitFile proc near
;- is set:	RDrive, RHandle (open), (NOT WHandle)
;- sets:	RHandle, WasteBuf, SecSize, fsize
	pusha
	
	mov	Error,0

	;- DOS-read can max. fill 65535 (64K-1) bytes
	;-> each 64K buf wastes (65535 mod SecSize)=WasteBuf bytes
	;-> you need (fsize div 65536) => nr of 64K bufs
	;->	     (...)*WasteBuf bytes more
	mov	ax,65535
	xor	dx,dx
	div	SecSize
	mov	WasteBuf,dx

	not	dx	;- =65535-dx
	mov	RBufSize,dx

	mov	ah,36h
	mov	dl,rdrive
	int	21h
	mov	SecSize,cx

	mov	ax,4202h
	mov	bx,RHandle
	xor	cx,cx
	xor	dx,dx
	int	21h
	adc	error,0 ;- make error<>0, if CF signaled Error

	mov	word ptr fsize[0],ax
	mov	word ptr fsize[2],dx
	mov	word ptr rleft[0],ax
	mov	word ptr rleft[2],dx
	mov	ax,4200h
	xor	cx,cx
	xor	dx,dx
	int	21h

	mov	ReadDone,0
	mov	WriteDone,0

	mov	BytesDone,0
	mov	RSize,0
	mov	DosErr,0
	mov	WriteErr,0
	mov	DrvChecked,0
	mov	PrgOfs,0
	mov	PrgLen,0

	popa
	ret
endp
;
ChkErr macro
	add	error,ah
	adc	error,0 ;- makes sure, it doesn't get 0 at overflow
	jnz	@@exit
endm
;
InitBuf proc near
;- is set:	fsize, RHandle, WasteBuf
;- sets:	bufsize, bufpages, frmseg, emmhandle
	pushae
	call	DoneBuf ;- only to be sure ;)

;- get EMS-Frame:
	mov	ah,41h
	int	67h
	mov	frmseg,bx
	ChkErr

;- get Buffersize:
	mov	ah,42h
	int	67h	;- DX trashed!
	ChkErr
	;- BX=number of free pages

	xor	eax,eax
	xor	ecx,ecx
	mov	ax,word ptr fsize[2]	;- That's the same as dword(fsize)/64K
	mov	cx,WasteBuf
	mul	ecx
	;-> wasted bytes
	add	eax,fsize
	;-> needed bufsize

	mov	ecx,eax
	shr	ecx,14	;- div 16K -> bytes2pages
	test	eax,3FFFh	;- chk for modulo 16K
	jz	@@NotOdd
	 inc	ecx	;- partly used last page
	@@NotOdd:
	;-> NeedSize: (EAX in bytes), (ECX in pages)


	and	ebx,0FFFFh

	cmp	ebx,ecx
	jae	@@BufSizeOk
	 ;- more pages needed than available => bufsize=freepages
	 mov	ecx,ebx
	@@BufSizeOk:
	and	cx,not 3	;- round down to x64K
	jnz	@@noerr
	 mov	error,1 ;- less than 64K available or needed -> conventional copy!
	 jmp	@@exit
	@@noerr:

	mov	BufPages,cx
	shl	ecx,14
	mov	BufSize,ecx

	test	ecx,0FFFF0000h
	jnz	@@BiggerThan64K
	 cmp	cx,RBufSize
	 jae	@@RBufSizeOK

	 mov	ax,cx
	 xor	dx,dx
	 div	SecSize
	 mov	WasteBuf,dx
	 sub	cx,dx
	 mov	RBufSize,cx

@@RBufSizeOK:
@@BiggerThan64K:
;- allocate buffer:
	mov	bx,BufPages
	mov	ah,43h
	int	67h
	ChkErr
	mov	EMMHandle,dx
	mov	allocated,1

	@@exit:
	popae
	ret
endp
;
DoneBuf proc near
;- free buffer
	pusha

	cmp	allocated,0
	je	@@NotAlloced

	mov	ah,45h
	mov	dx,emmhandle
	int	67h
	mov	allocated,0

	@@NotAlloced:

	popa
	ret
endp

;
;
;
Copying db 0	;- <>0, if copying was detected
;
StrYOfs dw 0	;- YOfs in seg B800h, where ID-Str was found
XLen	dw 0	;- TextLine-Len
;
StrCmp proc near
;- IN:	SI=ofs of StrTableEntry
;-OUT:	CF=0, if true

	pusha
	push	es

	push	40h
	pop	es
	mov	di,es:[4Ah]	;- XSize of screen
	add	di,di
	mov	XLen,di


	push	0b800h
	pop	es

	xor	bx,bx
	mov	bl,cs:[si+0]	;- X
	add	bx,bx
	xor	ax,ax
	mov	al,cs:[si+1]	;- Y
	xor	cx,cx
	mov	cl,cs:[si+2]	;- Len
	add	si,3

	;- AL=Y
	mul	di
	mov	StrYOfs,ax
	add	bx,ax

	;- CL=StrLen
	;- SI=StrOfs
	test	cx,cx
	stc
	jz	@@exit

@@CmpLoop:
	 mov	al,es:[bx]
	 cmp	cs:[si],al
	 jne	@@False
	 inc	si
	 add	bx,2
	loop	@@CmpLoop
@@False:	;- CX=0, if success
	sub	cx,1	;- CF=1, if CX was 0  (! DEC doesn't set CF !)
	cmc	;- CF=0, if success
@@exit:
 
	pop	es
	popa

	ret
endp
;
ChkID db 0	;- ID (1..4) of detected copy-action
Chk4Copy proc near
;- RETURNS CF=0, if copying was detected
	pusha

	push	es
	 push	40h
	 pop	es
	 mov	al,es:[17h]
	pop	es
	xor	cx,cx	;- ID=0
if debug

	test	al,10h	;- ScrollLock
	stc
	jz	@@nobrk
	int	03    
	@@nobrk:
endif

	cmp	ShiftDisable,0
	jz	@@NoSD
	 test	al,01h	;- RightShift
	 stc
	 jnz	@@exit
@@NoSD:	

	mov	cx,STEntryNum
	mov	si,offset StrTable
@@CmpLoop:
	 call	StrCmp
	 jnc	@@exit
	 add	si,STEntrySize
	loop	@@CmpLoop
	stc

@@exit:

	mov	ChkID,cl
	popa
	ret
endp
;
GetDrive proc near
;- in: DS:DX=>filename
;-out: AL=drive (1=A:,...)	(!AX destroyed!)
	xchg	bx,dx
	mov	ax,ds:[bx]
	xchg	bx,dx
	cmp	ah,':'
	jne	@@NoDrvSpec
	 cmp	al,'a'
	 jb	@@BigChar
	 sub	al,'a'-1
	 add	al,'A'-1	;- <evil-grin>
	 @@BigChar:
	 sub	al,'A'-1
	jmp	@@exit
	@@NoDrvSpec:

	mov	ah,19h	;- get current drive
	int	21h
	inc	al
	@@exit:
	ret
endp
;
ChkDrives proc near
;- returns ZF=1, if EMM-access allowed for RDrive and WDrive
	pusha

	mov	cl,rdrive
	call	near ptr @@1
	jnz	@@exit
	mov	cl,wdrive
	call	near ptr @@1
	@@exit:
	mov	DrvChecked,1

	popa
	ret
;
@@1:
	dec	cl
	cmp	cl,31
	ja	@@failes
	xor	bx,bx
	mov	bl,cl
	shr	bx,3	;- get ofs
	and	cl,7
	mov	al,1
	shl	al,cl
	test	byte ptr NoEMMDrives[bx],al
	retn
@@failes:
	test	cl,cl	;- make ZF=0
	retn
endp
;
NewInt21h proc far
assume cs:code, es:nothing, ss:nothing, ds:nothing
	cmp	ah,3Dh	;- open file
	je	@@open
	cmp	ah,3Ch	;- create file
	je	@@create

	cmp	ah,3Fh	;- read
	je	@@read
	cmp	ah,40h	;- write
	je	@@write

	cmp	ah,3Eh	;- close file
	je	@@close

	cmp	ah,4Bh	;- exec prog
	je	@@CloseBuf
	cmp	ah,4Ch	;- exit prog
	je	@@CloseBuf

	jmp	@@JmpToOld
;
@@open:
	call	Chk4Copy
	jc	@@JmpToOld
	
	cmp	al,1	;- 1=writeonly
	je	@@C_Create	;- File opened writeonly -> WHandle (trgfile)

	cmp	Copying,0
	jnz	@@JmpToOld

	push	ax     
	call	GetDrive
	mov	rdrive,al
	pop	ax     
                       
	;- open for copy -> RHandle
	pushf          
	call	[OldInt21]
	jc	@@exit
	
	mov	RHandle,ax
               
	call	InitFile
	cmp	Error,0
	jne	@@exit

	call	InitBuf
	cmp	Error,0
	jne	@@exitok

	mov	Copying,1
	jmp	@@exitok
;
@@create:
	cmp	Copying,0
	jnz	@@C_Create
	call	Chk4Copy
 	jc	@@JmpToOld
@@C_Create:
	push	ax
	call	GetDrive
	mov	wdrive,al
	pop	ax

	;- create for copy -> WHandle
	pushf
	call	[OldInt21]
	jc	@@exit
	mov	WHandle,ax
	jmp	@@exitok
;
@@read:
	cmp	Copying,0
	jz	@@JmpToOld
	cmp	bx,RHandle
	jne	@@JmpToOld
	
	cmp	WHandle,-1
	je	@@CloseBuf
	
	cmp	DrvChecked,0
	jnz	@@DrvChkDone
	 call	ChkDrives
	 jnz	@@CloseBuf
	 call	GetProgrPos
	@@DrvChkDone:

	call	DrawProgr

	call	ReadBuf
	cmp	doserr,0
	jz	@@ReadOK
	 xor	ax,ax
	 xchg	ax,doserr
	 stc
	jmp	@@exit
@@ReadOK:
if FastExit
	xor	ax,ax
	cmp	ReadDone,0
	jne	@@ReadEnd
	mov	ax,cx
	@@ReadEnd:
else
	mov	ax,cx
	push	eax

	and	eax,0FFFFh
	sub	rleft,eax
	jae	@@ReadR_ALL
	 pop	eax
	 add	ax,word ptr rleft
	 mov	rleft,0
	 jmp	@@ReadR_END
	@@ReadR_ALL:
	pop	eax
	@@ReadR_END:
endif
	jmp	@@exitok
;
@@write:
	cmp	Copying,0
	jz	@@JmpToOld
	cmp	bx,WHandle
	jne	@@JmpToOld
	cmp	WriteDone,0
	jnz	@@WriteDone
	cmp	rsize,0
	jz	short @@JmpToOld

@@CopyLoop:
	call	ReadBuf
	cmp	break,0
	jnz	@@WriteDone
	call	WriteBuf
	cmp	break,0
	jnz	@@WriteDone
	cmp	WriteDone,0
	jz	@@CopyLoop
@@WriteDone:
	cmp	doserr,0
	jz	@@WriteOK
	 xor	ax,ax
	 xchg	ax,doserr
	 stc
	jmp	@@exit
@@WriteOK:
	mov	ax,cx
	cmp	WriteErr,0
	je	@@WriteR_ALL
	 xor	ax,ax
	@@WriteR_ALL:
	jmp	@@exitok
;
@@close:
	cmp	Copying,0
	jz	@@JmpToOld
	cmp	bx,RHandle
	je	@@CloseBuf
	cmp	bx,WHandle
	je	@@CloseBufW
	jmp	@@JmpToOld
;
;
@@CloseBuf:
	mov	Copying,0
	mov	RHandle,-1
	call	DoneBuf
@@CloseBufW:
	mov	WHandle,-1

	jmp	@@JmpToOld
;
@@exitok:                
	clc              
	jmp	@@exit   
@@exit:
	sti
	retf	2
;
@@JmpToOld:

jmp	cs:[OldInt21]

endp     
;
;
;
;---------------------------------------------------------
EndOfResident equ this byte
;
EMMID	db "EMMXXXX0"
;
begin:             
		assume es:code, ss:nothing, ds:code, cs:code
                   
		mov	ah,9
		mov	dx,offset mInfo
		int	21h

		mov	ax,3521h
		int	21h

		cmp	word ptr es:[0], resid
		jnz	install
;
; ---- Already installed ---> remove from memory

		call	DoneBuf

		lds	dx,es:OldInt21
		mov	ax,2521h
		int	21h
		jb	NotRemoved

		mov	ah,49h
		int	21h

		jb	NotRemoved

		push	cs
		pop	ds
		mov	ah,9
		mov	dx,offset mRemoved
		int	21h

		mov	ax,4C00h
		int	21h
	;
	NotRemoved:
		push	cs
		pop	ds
		mov	ah,9
		mov	dx,offset mNotRemoved
		int	21h

		mov	ax,4C01h
		int	21h
;
Install:
		;- just save OLD-21h-vector (ES:BX), before it gets destroyed ;)
		mov	word ptr cs:[0],resid
		mov	word ptr OldInt21[2],es
		mov	word ptr OldInt21[0],bx

		;- chk for EMM-presence:
		mov	ax,3567h
		int	21h
		;- ES => 67h-seg
		mov	di,0Ah	;- name-field offset
		lea	si,EMMID
		mov	cx,8
		cld
		repe	cmpsb
		jne	@@EMMError



		mov	dx,offset NewInt21h
		mov	ax,2521h
		int	21h

		;- release unneeded environment-mem
		xor	ax,ax
		xchg	ax,cs:[2Ch]
		mov	es,ax
		mov	ah,49h
		int	21h

		;- Install-msg
		mov	ah,9
		mov	dx,offset mInstalled
		int	21h

		;- Terminate (myself ;) and stay resident
		mov	dx,offset EndOfResident
		shr	dx,4
		inc	dx ;- to round up to next 16th
		mov	ax,3100h
		int	21h
;
@@EMMError:
		mov	ah,9
		mov	dx,offset mEMMError
		int	21h

		mov	ax,4C01h
		int	21h
;
;
mInfo		db 'Ŀ',0Dh,0Ah
		db ' TC-PATCH v1.2    This program is FREEWARE.    ',0Dh,0Ah
		db '                  Copyright by Tobias Winkler. ',0Dh,0Ah
		db ' ---TurboCopy-Patch for filemanagers---------- ',0Dh,0Ah
		db '',0Dh,0Ah,'$'
mInstalled	db 'INSTALLED. Run again to remove.',0Dh,0Ah,'$'
mEMMError	db 'NOT INSTALLED! (EMS needed, but not available -> install EMM386)',0Dh,0Ah,'$'
mRemoved	db 'REMOVED.',0Dh,0Ah,'$'
mNotRemoved	db 'Could not remove!',0Dh,0Ah,'$'
;
;
dw ResID
dw offset CfgData
db STEntryNum
db STMaxStrLen
db STEntrySize
;
ends
end	start
